#include "testlib.h"

using namespace std;

typedef long long ll;

int MAXT = 50;
ll MAXN = 1'000'000'000'000'000'000LL;

int main(int argc, char **argv)
{
    registerValidation(argc, argv);
    int g = validator.group() == "" ? 0 : validator.group()[0] - '0';

    if (g == 1) { MAXN = 100; }
    if (g == 2) { MAXN = 100'000; }
    if (g == 4) { MAXN = 1'000'000'000; }

    int t = inf.readInt(1, MAXT, "t");
    inf.readEoln();
    for (int i = 0; i < t; i++) {
        ll n = inf.readLong(2, MAXN, "n");
        inf.readEoln();
        if (g == 3) {
            ensuref((n & (n - 1)) == 0, "group 3, n must be power of 2");
        }
    }
    inf.readEof();

    return 0;
}
