#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

vector<ll> fib;
const ll MAX = 1'000'000'000'000'000'000LL;

ll bt(ll n, int p) {
    if (n == 1) return 1;
    if (p >= fib.size()) return 0;
    if (n < fib[p]) return 0;

    ll res = bt(n, p + 1);
    if (n % fib[p] == 0) {
        res += bt(n / fib[p], p);
    }
    return res;
}

ll solve(ll n) {
    return bt(n, 0);
}

int main() {
    fib.push_back(2);
    fib.push_back(3);
    ll f1 = 2;
    ll f2 = 3;
    while (f1 + f2 <= MAX) {
        fib.push_back(f1 + f2);
        ll t = f1 + f2;
        f1 = f2;
        f2 = t;
    }

    int tn;
    cin >> tn;
    for (int test = 0; test < tn; test++) {
        ll n;
        cin >> n;
        cout << solve(n) << endl;
    }
    return 0;
}
