#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

vector<pair<ll, ll>> merge(vector<pair<ll, ll>> &data, ll &answer) {
    vector<pair<ll, ll>> seg;
    sort(all(data));

    auto [cur_l, cur_r] = data[0];
    for (auto [l, r] : data) {
        if (l > cur_r + 1) {
            seg.emplace_back(cur_l, cur_r);
            answer += cur_r - cur_l + 1;
            cur_l = l, cur_r = r;
        } else {
            cur_r = max(cur_r, r);
        }
    }
    seg.emplace_back(cur_l, cur_r);
    answer += cur_r - cur_l + 1;

    return seg;
}

int main() {

    in(int, k, n)
    unordered_map<char, pair<ll, ll>> const move{
            {'N', {0,  1}},
            {'S', {0,  -1}},
            {'W', {-1, 0}},
            {'E', {1,  0}}
    };

    ll x = 0, y = 0;
    map<ll, vector<pair<ll, ll>>> hlines, vlines;

    for (int i = 0; i < n; i++) {
        in(char, d)
        in(int, a)
        auto dir = move.at(d);

        if (dir.first != 0) {
            ll xx = x + dir.first * a;
            hlines[y].emplace_back(min(xx, x), max(xx, x));
            x = xx;
        } else {
            ll yy = y + dir.second * a;
            vlines[x].emplace_back(min(yy, y), max(yy, y));
            y = yy;
        }
    }

    ll answer = 0;
    typedef pair<ll, vector<pair<ll, ll>>> line;
    auto cmp1 = [](line &v, ll xx) {
        return v.first < xx;
    };
    auto cmp2 = [](ll xx, line &v) {
        return xx < v.first;
    };

    vector<line> vstrips;
    for (auto &p : vlines) {
        auto seg = merge(p.second, answer);
        vstrips.emplace_back(p.first, seg);
    }

    for (auto &p : hlines) {
        auto seg = merge(p.second, answer);
        for (auto &s : seg) {
            auto [l, r] = s;
            int from = lower_bound(all(vstrips), l, cmp1) - vstrips.begin(),
                    to = upper_bound(all(vstrips), r, cmp2) - vstrips.begin();
            pair<ll, ll> key{p.first, numeric_limits<ll>::max()};
            for (int i = from; i < to; i++) {
                auto pos = upper_bound(all(vstrips[i].second), key);
                if (pos != vstrips[i].second.begin()) {
                    if ((--pos)->second >= p.first) answer--;
                }
            }
        }
    }

    cout << answer << '\n';

}