#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, k, n)

    set<pair<ll, ll>> cells;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            cells.insert({i, j});
        }
    }
    ll x = 0, y = 0;

    unordered_map<char, pair<ll, ll>> const move{
            {'N', {0,  1}},
            {'S', {0,  -1}},
            {'W', {-1, 0}},
            {'E', {1,  0}}
    };

    for (int i = 0; i < n; i++) {
        in(char, d)
        in(int, a)
        auto dir = move.at(d);

        for (int t = 0; t < a; t++) {
            x += dir.first;
            y += dir.second;
            if (dir.first == 1) {
                for (ll yy = y; yy < y + k; yy++) {
                    cells.insert({x + k - 1, yy});
                }
            } else if (dir.first == -1) {
                for (ll yy = y; yy < y + k; yy++) {
                    cells.insert({x, yy});
                }
            } else if (dir.second == 1) {
                for (ll xx = x; xx < x + k; xx++) {
                    cells.insert({xx, y + k - 1});
                }
            } else {
                for (ll xx = x; xx < x + k; xx++) {
                    cells.insert({xx, y});
                }
            }
        }
    }

    cout << cells.size() << '\n';

}